#include "demo_dlg.h"

/*****************************************************************************
    Prototypes for the internal demo functions.
******************************************************************************/
BOOL GeneratePdf(HWND);
BOOL WriteToFile(LPBYTE, HGLOBAL, int);
int  DemoOther(void);
int  GetFileName(BOOL,LPBYTE,LPBYTE,LPBYTE);
int  PASCAL WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
int  FAR PASCAL _export DemoDlg(HWND,UINT,WPARAM,LPARAM);
int  OurPrintf(LPSTR,...);
int  SetGuiFont(HWND,int);
BOOL CallFunction(HWND,int,BOOL);
BOOL DisableInputArea(HWND);
BOOL EnableInputArea(HWND,BOOL,LPBYTE,BOOL);
BOOL InitApplication(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);
BOOL InsertTable(void);
BOOL AssignIntValue(HWND,int,LPINT);
BOOL AssignLongValue(HWND,int,LPLONG);
BOOL SetFont(HWND);
BOOL SetFunctionName(HWND,int,LPBYTE);
BOOL SetFunctionNames(HWND);
BOOL ShowRtfCode(HWND);

/* Demo Global Variables */

HWND hDemoWnd;                     // demo window handle
HINSTANCE hInst;                   // demo program instance
FARPROC lpDemoDlg;                 // demo dialog box pointer

BOOL mbcs;                         // TRUE when working in an mbcs operating system
BOOL ProcessMsg=FALSE;             // TRUE when processing the messages

DWORD RepId=0;                     // report id
DWORD DocId=0;                     // document id
int   CurFct;                      // selected API
int   StyleItemCount=0;            // stylesheet item id

BOOL  AutoRefresh=TRUE;            // refresh the code window after each function

int   InputBoxWidth;               // width of the input box
int   InputBoxHeight;              // height of the input box

// unit conversion macros
int  ResX;                         // pixels per inch in x direction
int  ResY;                         // pixels per inch in y direction

char CurTypeface[32]="Arial";      // current type face to insert new text 
int  CurPointSize=12;              // current point size    
UINT CurStyle=0;                   // current character styles 
COLORREF CurColor=0;               // current text color - black

LPBYTE FctName[200];               // function names

#define    ResetLongFlag(flags,flag)  (flags=(DWORD)(flags)&(~((DWORD)(flag))))

// Demo function ids
#define ID_NEW             0       // new docuemnt
#define ID_INIT_SECT       1       // initialize section
#define ID_BEGIN_TEXT      2       // begin text
#define ID_RESET_CHAR_PROP 3       // reset the character properties
#define ID_SET_FONT        4       // set font/color
#define ID_CHAR_STYLE_ID   5       // specify the character style id
#define ID_RESET_PARA_PROP 6       // reset the paragraph properties
#define ID_PARA_CENTER     7       // centered paragraph
#define ID_PARA_RIGHT      8       // right justified paragraph
#define ID_PARA_DOUBLE_SPACE 9     // double space paragraph
#define ID_PARA_BORDER     10      // paragraph border
#define ID_PARA_INDENT     11      // paragraph indentation
#define ID_PARA_SPACE      12      // paragraph spacing
#define ID_PARA_SHADE      13      // paragraph shading
#define ID_PARA_BULLET     14      // paragraph bullet
#define ID_PARA_NUMBERING  15      // paragraph numbering
#define ID_PARA_TAB_STOP   16      // paragraph tab stops
#define ID_PARA_STYLE_ID   17      // specify the paragraph style id
#define ID_INSERT_TEXT     18      // append text
#define ID_INSERT_TABLE    19      // insert a table
#define ID_INSERT_PICT     20      // insert a picture file as linked
#define ID_INSERT_LINK_PICT 21     // insert a picture file as linked
#define ID_PASTE_PICT      22      // paste from clipboard or memory
#define ID_PAPER           23      // set paper size
#define ID_MARGIN          24      // set margin
#define ID_SECT_INFO       25      // section information
#define ID_BEGIN_HDR       26      // begin the header group
#define ID_END_HDR         27      // end the header group
#define ID_BEGIN_FTR       28      // begin the footer group
#define ID_END_FTR         29      // end the footer group
#define ID_BEGIN_STYLESHEET 30     // begin stylesheet
#define ID_BEGIN_STYLEITEM 31      // begin a style item
#define ID_END_STYLEITEM   32      // end styleitem
#define ID_END_STYLESHEET  33      // end stylesheet
#define ID_BEGIN_FRAME     34      // begin a frame
#define ID_END_FRAME       35      // end the current frame
#define ID_BEGIN_TEXT_BOX  36      // begin a text box
#define ID_END_TEXT_BOX    37      // end the current text box
#define ID_DRAW_RECT       38      // draw a rectangle
#define ID_DRAW_LINE       39      // draw a line
#define ID_PAGE_BREAK      40      // insert a page break
#define ID_SECT_BREAK      41      // insert a section break
#define ID_INSERT_PAGE_NO  42      // insert a page number and total pages
#define ID_INSERT_MERGE_FIELD 43   // insert merge field
#define ID_INSERT_TOC      44      // insert toc
#define ID_INSERT_RAW      45      // insert raw rtf code
#define ID_INSERT_FNOTE    46      // insert footenote
#define ID_INSERT_UTEXT    47      // append text
#define ID_OTHER           48      // testing code


