unit Dmo_dlp1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    fct: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    rtf: TMemo;
    FontDialog1: TFontDialog;
    TextInput: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    OutputFile: TEdit;
    TransferAsBuffer: TCheckBox;
    msg: TLabel;
    GeneratePdf: TButton;
    procedure FormCreate(Sender: TObject);
    procedure fctClick(Sender: TObject);
    procedure GeneratePdfClick(Sender: TObject);
  private
    { Private declarations }
    procedure CallFunction(fct: Integer);

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  {$I rcg.pas}
  {$I pdg.pas}

{******************************************************************************
                      Global Constants for the Demo program
******************************************************************************}
const

   { function ids }
   ID_NEW = 0;
   ID_INIT_SECT = 1;
   ID_BEGIN_TEXT = 2;
   ID_RESET_CHAR_PROP = 3;
   ID_SET_FONT = 4;
   ID_CHAR_STYLE_ID = 5;
   ID_RESET_PARA_PROP = 6;
   ID_PARA_CENTER = 7;
   ID_PARA_RIGHT = 8;
   ID_PARA_DOUBLE_SPACE = 9;
   ID_PARA_BORDER = 10;
   ID_PARA_INDENT = 11;
   ID_PARA_SPACE = 12;
   ID_PARA_SHADE = 13;
   ID_PARA_BULLET = 14;
   ID_PARA_NUMBERING = 15;
   ID_PARA_TAB_STOP = 16;
   ID_PARA_STYLE_ID = 17;
   ID_INSERT_TEXT = 18;
   ID_INSERT_TABLE = 19;
   ID_INSERT_PICT = 20;
   ID_INSERT_LINK_PICT = 21;
   ID_PAPER = 22;
   ID_MARGIN = 23;
   ID_SECT_INFO = 24;
   ID_BEGIN_HDR = 25;
   ID_END_HDR = 26;
   ID_BEGIN_FTR = 27;
   ID_END_FTR = 28;
   ID_BEGIN_STYLESHEET = 29;
   ID_BEGIN_STYLEITEM = 30;
   ID_END_STYLEITEM = 31;
   ID_END_STYLESHEET = 32;
   ID_BEGIN_FRAME = 33;
   ID_END_FRAME = 34;
   ID_BEGIN_TEXT_BOX = 35;
   ID_END_TEXT_BOX = 36;
   ID_DRAW_RECT = 37;
   ID_DRAW_LINE = 38;
   ID_PAGE_BREAK = 39;
   ID_SECT_BREAK = 40;
   ID_OTHER = 41;

{******************************************************************************
                      Global Variables for the Demo program
******************************************************************************}
var

  RepId: LongInt;          {current reporting seesion}
  DocId: LongInt;          { document id for the current reporting session}
  StyleItemCount: Integer; { stylesheet item counter}

{*******************************************************************
    Program Function declarations
 *******************************************************************}
function ShowRtfCode(rtf: TMemo): WordBool;
procedure InsertTable;
procedure DemoOther;



implementation

{$R *.DFM}

{$I rcg_prot.pas}
{$I pdg_prot.pas}

procedure TForm1.FormCreate(Sender: TObject);
begin
    {Load the avaialble function names in the list box}

    fct.items.AddObject('New Document', TObject(ID_NEW));
    fct.items.AddObject('Initialize Section', TObject(ID_INIT_SECT));
    fct.items.AddObject('Begin Section Text', TObject(ID_BEGIN_TEXT));
    fct.items.AddObject('Reset Character Properties', TObject(ID_RESET_CHAR_PROP));
    fct.items.AddObject('Set Font...', TObject(ID_SET_FONT));
    fct.items.AddObject('Set Character Style Id', TObject(ID_CHAR_STYLE_ID));
    fct.items.AddObject('Reset Paragraph Properties', TObject(ID_RESET_PARA_PROP));
    fct.items.AddObject('Paragraph Centering', TObject(ID_PARA_CENTER));
    fct.items.AddObject('Paragraph Right Justification', TObject(ID_PARA_RIGHT));
    fct.items.AddObject('Paragraph Double Spacing', TObject(ID_PARA_DOUBLE_SPACE));
    fct.items.AddObject('Paragraph Border', TObject(ID_PARA_BORDER));
    fct.items.AddObject('Paragraph Indents', TObject(ID_PARA_INDENT));
    fct.items.AddObject('Paragraph Spacing', TObject(ID_PARA_SPACE));
    fct.items.AddObject('Paragraph Shading', TObject(ID_PARA_SHADE));
    fct.items.AddObject('Paragraph Bullet', TObject(ID_PARA_BULLET));
    fct.items.AddObject('Paragraph Numbering', TObject(ID_PARA_NUMBERING));
    fct.items.AddObject('Paragraph Tab Stops', TObject(ID_PARA_TAB_STOP));
    fct.items.AddObject('Set Paragraph Style Id', TObject(ID_PARA_STYLE_ID));
    fct.items.AddObject('Insert Text...', TObject(ID_INSERT_TEXT));
    fct.items.AddObject('Insert Table', TObject(ID_INSERT_TABLE));
    fct.items.AddObject('Insert a Picture file...', TObject(ID_INSERT_PICT));
    fct.items.AddObject('Insert a Linked Picture file...', TObject(ID_INSERT_LINK_PICT));
    fct.items.AddObject('Set Paper Size', TObject(ID_PAPER));
    fct.items.AddObject('Set Page Margin', TObject(ID_MARGIN));
    fct.items.AddObject('Set Section Information', TObject(ID_SECT_INFO));
    fct.items.AddObject('Begin Header Group', TObject(ID_BEGIN_HDR));
    fct.items.AddObject('End Header Group', TObject(ID_END_HDR));
    fct.items.AddObject('Begin Footer Group', TObject(ID_BEGIN_FTR));
    fct.items.AddObject('End Footer Group', TObject(ID_END_FTR));
    fct.items.AddObject('Begin Stylesheet', TObject(ID_BEGIN_STYLESHEET));
    fct.items.AddObject('Begin a Stylesheet Item', TObject(ID_BEGIN_STYLEITEM));
    fct.items.AddObject('End a Stylesheet Item', TObject(ID_END_STYLEITEM));
    fct.items.AddObject('End Stylesheet', TObject(ID_END_STYLESHEET));
    fct.items.AddObject('Begin Frame Group', TObject(ID_BEGIN_FRAME));
    fct.items.AddObject('End Frame Group', TObject(ID_END_FRAME));
    fct.items.AddObject('Begin a Text Box Group', TObject(ID_BEGIN_TEXT_BOX));
    fct.items.AddObject('End Text Box Group', TObject(ID_END_TEXT_BOX));
    fct.items.AddObject('Draw a Rectangle', TObject(ID_DRAW_RECT));
    fct.items.AddObject('Draw a Line', TObject(ID_DRAW_LINE));
    fct.items.AddObject('Insert a page break', TObject(ID_PAGE_BREAK));
    fct.items.AddObject('Insert a section break', TObject(ID_SECT_BREAK));
    fct.items.AddObject(' ', TObject(ID_OTHER));

    {begin the first report}
    RepId := 0;
    DocId := 0;
    CallFunction(ID_NEW);

    TextInput.text:= 'This is sample text';
    rtf.ReadOnly := True;

end;

{*****************************************************************************
    CallFunction:
    Call the specified function.
*****************************************************************************}
procedure TForm1.CallFunction(fct: Integer);
var
    i,CurStyle: Integer;
    name: array [0..33] of char;
    InText: array[0..255] of char;

begin

    case fct of
      ID_NEW:
        begin
          if RepId <> 0 then PdgEndSession(RepId);  // close previous ession
          RepId:=PdgNewSession();            // start new reporting session
          DocId:=PdgNewDocObject(RepId);     // create document for the reporting session
        end;

      ID_BEGIN_STYLESHEET:          { begin the stylesheet group}
         RcgBeginStyleSheet(DocId);

      ID_BEGIN_STYLEITEM:           { begin a stylesheet item}
         begin
            RcgBeginStyleItem(DocId,True,StyleItemCount,'Normal');
            StyleItemCount:=StyleItemCount+1;
         end;


      ID_END_STYLEITEM:              { end current stylesheet item}
         RcgEndStyleItem(DocId);

      ID_END_STYLESHEET:             { end current stylesheet group}
         RcgEndStyleSheet(DocId);


      ID_PAPER:                     { set paper size to 8.5 by 11 inches}
         RcgPaper(DocId,round(8.5*1440),round(11*1440),False);


      ID_MARGIN:                     { set 1 inche margin around}
         RcgMargin(DocId,1440,1440,1440,1440,-1,-1);


      ID_INIT_SECT:                 { initialize the section}
         RcgInitSect(DocId);

      ID_SECT_INFO:                 { set the initial page number at 30}
         RcgSectInfo(DocId,1,0,True,30);

      ID_BEGIN_HDR:                 { begin the header group}
         RcgBeginHdrFtr(DocId,RCG_HDR);

      ID_END_HDR:                   { end the header group}
         RcgEndHdrFtr(DocId);

      ID_BEGIN_FTR:                 { begin the footer group}
         RcgBeginHdrFtr(DocId,RCG_FTR);

      ID_END_FTR:                   { end the footer group}
         RcgEndHdrFtr(DocId);

      ID_BEGIN_FRAME:               { begin the footer group}
         RcgBeginFrame(DocId,True,2000,2000,4000,4000);

      ID_END_FRAME:                 { end the footer group}
         RcgEndFrame(DocId);

      ID_BEGIN_TEXT_BOX:            { begin the text box group}
         RcgBeginTextBox(DocId,True,1500,1500,2000,2000,-1,$FFFFFF,0,20,FALSE);
         

      ID_END_TEXT_BOX:              { end the text box  group}
         RcgEndTextBox(DocId);

      ID_DRAW_RECT:                 { draw a rectangle}
         RcgDrawRect(DocId,True,3500,3500,2000,2000,-1,$FFFF,0,20,FALSE);


      ID_DRAW_LINE:                 { draw a line}
         RcgDrawLine(DocId,True,2500,2500,3500,3500,-1,$FF,60);
         

      ID_PAGE_BREAK:                 { page break}
         RcgInsertBreak(DocId,RCG_BREAK_PAGE);

      ID_SECT_BREAK:                 { page break}
         RcgInsertBreak(DocId,RCG_BREAK_SECT);

      ID_BEGIN_TEXT:                { text begins}
         RcgBeginSectText(DocId);

      ID_RESET_CHAR_PROP:           { reset the character properties}
         RcgResetTextProp(DocId);

      ID_RESET_PARA_PROP:           { reset the paragraph properties}
         RcgResetParaProp(DocId);

      ID_SET_FONT:
         begin
           if FontDialog1.execute then
           begin
              CurStyle := 0;
              If (FontDialog1.font.style = [fsBold]) Then CurStyle := CurStyle Or RCG_BOLD;
              If (FontDialog1.font.style = [fsItalic]) Then CurStyle := CurStyle Or RCG_ITALIC;
              If (FontDialog1.font.style = [fsUnderline]) Then CurStyle := CurStyle Or RCG_ULINE;
              If (FontDialog1.font.style = [fsStrikeout]) Then CurStyle := CurStyle Or RCG_STRIKE;

              StrPCopy(name,FontDialog1.font.name);
              RcgTextFont(DocId, name, FontDialog1.font.size, CurStyle, True);
              RcgTextColor(DocId, FontDialog1.font.Color, True);
           end;
         end;

      ID_CHAR_STYLE_ID:             { specify the character style id}
         RcgCharStyleId(DocId,1);

      ID_PARA_CENTER:               { specify the paragraph centering}
         RcgParaFlags(DocId,RCG_CENTER);

      ID_PARA_RIGHT:               { specify the paragraph right justification}
         RcgParaFlags(DocId,RCG_RIGHT);

      ID_PARA_DOUBLE_SPACE:        { specify the paragraph double spacing}
         RcgParaFlags(DocId,RCG_DOUBLE_SPACE);

      ID_PARA_BORDER:              { Apply single width paragraph border}
         RcgParaFlags(DocId,RCG_PARA_BOX);

      ID_PARA_INDENT:              { Apply paragraph indentation}
         RcgParaIndent(DocId,1440,1440,1440);

      ID_PARA_SPACE:               { Apply paragraph spacing}
         RcgParaSpace(DocId,720,720,400);

      ID_PARA_SHADE:               { Apply paragraph shading}
         RcgParaShadeColor(DocId,30,0);

      ID_PARA_BULLET:               { Apply paragraph bullet}
         begin
            RcgParaIndent(DocId,720,720,-720);
            RcgParaBullet(DocId,True,BLT_ROUND,0,1,'','',0);
         end;


      ID_PARA_NUMBERING:           { Apply paragraph Numbering}
         begin
            RcgParaIndent(DocId,720,720,-720);
            RcgParaBullet(DocId,FALSE,NBR_DEC,0,1,'(',')',0);
         end;
         

      ID_PARA_TAB_STOP:            { create paragraph tab stops}
         begin
            RcgParaTabStop(DocId,0,1440,0);      { at one inch}
            RcgParaTabStop(DocId,0,3*1440,0);    { at 3 inch}
            RcgParaTabStop(DocId,TAB_RIGHT,5*1440,TAB_DOT);  { right tab with dot leader at 5 inches}
         end;


      ID_PARA_STYLE_ID:             { specify the paragraph style id}
         RcgParaStyleId(DocId,1);

      ID_INSERT_TEXT:
         begin
            StrPCopy(InText,TextInput.text);
            RcgInsertText(DocId,InText);       {insert the text into the rtf buffer}
         end;

      ID_INSERT_TABLE:
         InsertTable;

      ID_INSERT_PICT:
         begin
            OpenDialog1.DefaultExt:='bmp';
            OpenDialog1.Filter:='Bitmap File(*.BMP)|*.BMP|Windows Metafile(*.WMF)|*.WMF|';

            if OpenDialog1.execute then
              begin
               StrPCopy(InText,OpenDialog1.FileName);
               RcgInsertPictFile(DocId,InText,0,0,False);       {save the code the file}
              end;
         end;


      ID_INSERT_LINK_PICT:
         begin
            OpenDialog1.DefaultExt:='bmp';
            OpenDialog1.Filter:='Bitmap File(*.BMP)|*.BMP|Windows Metafile(*.WMF)|*.WMF|';

            if OpenDialog1.execute then
              begin
               StrPCopy(InText,OpenDialog1.FileName);
               RcgInsertPictFile(DocId,InText,0,0,True);       {save the code the file}
              end;
         end;



      ID_OTHER:                        { this code is for miscellaneous testing}
         DemoOther;
    end;

    ShowRtfCode(rtf);

end;

{*****************************************************************************
    ShowRtfCode:
    show the generated rtf code.
*****************************************************************************}
function ShowRtfCode(rtf: TMemo) : WordBool;
var
    BufLen: LongInt;
    hMem: THandle;
    pMem: pChar;

begin

    hMem:=RcgGetData(DocId,BufLen);  {retrieve the data in a global memory handle}

    pMem:=GlobalLock(hMem);   {lock the handle to get the data pointer}

    rtf.SetTextBuf(pMem);

    GlobalUnlock(hMem);       {unlock the memory before freeing it}
    GlobalFree(hMem);         {free the memory handle}

    result:=True;
end;

{*****************************************************************************
    InsertTable:
    Insert a table.
*****************************************************************************}
procedure InsertTable;
begin
          { Create the header row.}
    RcgBeginTableRow(DocId,0,0,RCG_CENTER,FALSE,0);
    RcgNextCellInfo(DocId,3*1440,0,30,$FFFFFF,20,40,20,40,0);
    RcgNextCellInfo(DocId,1440,0,30,$FFFFFF,40,20,20,40,0);

    { row 1 col 1}
    RcgBeginCellText(DocId);
    RcgResetTextProp(DocId);
    RcgTextFont(DocId,'',0,RCG_BOLD,True);
    RcgInsertText(DocId,'Products');
    RcgEndCellText(DocId);

    { row 1 col 2}
    RcgBeginCellText(DocId);
    RcgResetTextProp(DocId);
    RcgTextFont(DocId,'',0,RCG_BOLD,True);
    RcgInsertText(DocId,'Price');
    RcgEndCellText(DocId);

    RcgEndTableRow(DocId);

    {create the second row}
    RcgBeginTableRow(DocId,0,0,RCG_CENTER,FALSE,0);
    RcgNextCellInfo(DocId,3*1440,0,0,$FFFFFF,20,40,40,20,0);
    RcgNextCellInfo(DocId,1440,0,0,$FFFFFF,40,20,40,20,0);

    { row 2 col 1}
    RcgBeginCellText(DocId);
    RcgResetTextProp(DocId);
    RcgInsertText(DocId,'TE Developer''s Kit');
    RcgEndCellText(DocId);

    {row 2 col 2}
    RcgBeginCellText(DocId);
    RcgResetTextProp(DocId);
    RcgInsertText(DocId,'$439.00');
    RcgEndCellText(DocId);

    RcgEndTableRow(DocId);

    {create the third row}
    RcgBeginTableRow(DocId,0,0,RCG_CENTER,False,0);
    RcgNextCellInfo(DocId,3*1440,0,0,$FFFFFF,20,40,20,20,0);
    RcgNextCellInfo(DocId,1440,0,0,$FFFFFF,40,20,20,20,0);

    {row 2 col 1}
    RcgBeginCellText(DocId);
    RcgResetTextProp(DocId);
    RcgInsertText(DocId,'ReportEase Plus');
    RcgEndCellText(DocId);

    {row 2 col 2}
    RcgBeginCellText(DocId);
    RcgResetTextProp(DocId);
    RcgInsertText(DocId,'$459.00');
    RcgEndCellText(DocId);

    RcgEndTableRow(DocId);

end;

{*****************************************************************************
    DemoOther:
    Test code.
*****************************************************************************}
procedure DemoOther;
var
  RepId: LongInt;
  DocId: LongInt;
begin

  RepId:=PdgNewSession;  { start new reporting session }
  DocId:=PdgNewDocObject(RepId);	{ begin new document, and return a
                             document handle}
  RcgInitSect(DocId);	{ begin first section}
  RcgBeginSectText(DocId); { begin the text for the section}
  RcgTextFont(DocId, 'Times New Roman', 12, RCG_BOLD, TRUE);
  RcgInsertText(DocId, 'This is the first line' + chr(13) +
    chr(10));      { Ascii 13/10 pair terminates the paragraph}
  RcgTextFont(DocId, 'Arial', 12, RCG_BOLD, FALSE);
  RcgParaFlags(DocId,RCG_CENTER);
  RcgInsertText(DocId, 'This is the second paragraph' +
                chr(13) + chr(10));

  PdgGenerateReportFile(RepId, DocId, 'test.pdf'); {generate PDF}

  PdgEndSession(RepId);        {free the current document handle}
end;

procedure TForm1.fctClick(Sender: TObject);
begin
  CallFunction(fct.ItemIndex);
end;


procedure TForm1.GeneratePdfClick(Sender: TObject);
var
   pOutFile: array[1..256] of char;
   oFile: string;
   OutString: string;
   OutSize:LongInt;
   result: LongBool;
   hOutText: THandle;
   len: LongInt;

begin

   msg.Caption := 'Converting....';   // show the progress status
   result := False;

   if (TransferAsBuffer.Checked) then
    begin
     hOutText:=PdgGenerateReportBuffer(RepId, DocId, OutSize);

     If (hOutText<>0) Then
      begin
       SetLength(OutString,OutSize+1);
       PdgHandleToStr(PChar(OutString),OutSize,hOutText);
       rtf.Text:=OutString;
       result:=true;
      end
    end
   else
    begin
     oFile:=OutputFile.Text+#0;
     StrPCopy(addr(pOutFile),oFile);
     If (PdgGenerateReportFile(RepId,DocId, addr(pOutFile))<>0) Then result := True;
    end;

   If (result) Then msg.Caption := 'Done!' Else msg.Caption := 'Error';

end;

end.
